Chuyển đến nội dung
Diễn đàn CADViet
  • Thông báo

    • Nguyen Hoanh

      CADViet đã hoàn tất nâng cấp   14/09/2017

      Chào các bạn, CADViet đã hoàn tất việc nâng cấp lên phiên bản mới. Tất cả các chức năng đã hoạt động theo kỳ vọng của ban quản trị. Nếu có vấn đề gì cần phản hồi, các bản post ở đây nhé: Trân trọng, Nguyễn Hoành.
Đăng nhập để thực hiện theo  
AndUp

Xin Lisp Tự Động Đo Chiều Dài Nhiều Line (Ko Tính Tổng)

Các bài được khuyến nghị

ví dụ em có 100 đường line rời rạc nằm đủ kiểu khác nhau nếu ngồi dim từng đường rất lâu nên nhờ các bác viết giúp em lisp chỉ cần quét qua tất cả các line là sẽ tự cho ra kết quả chiều dài của từng line, kết quả có thể trình bày theo dạng đường dim cũng được (nằm sát đường line ) hoặc dạng text sao cho text nằm trên đường line (không đè cắt ngang đường line) và góc quay của text cùng góc với từng đường line (text nằm song song ấy ạ)

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Quick code cho bạn :

(defun c:qdd(/ s sp 3d i dxf rAng rSup e obj) (vl-load-com)
;Quick dim Lines @ketxu 10/2016
(cond
	((setq s (ssget '((0 . "LINE")))) 
	(setq 	sp	(vlax-get (setq ac (vla-get-activedocument (vlax-get-acad-object)))
					(if (> (vla-get-activespace  ac) 0) 'ModelSpace 'PaperSpace)) 
			3d vlax-3d-point
			i -1
			dxf (lambda(i e)(cdr (assoc i (entget e))))
			rAng (lambda(a)(if (and (> a (/ pi 2.)) (<= a (* pi 1.5)))(+ a pi) a))
			rSup (lambda(p)(vlax-put-property obj p 1))
			
	)
	(while (setq e (ssname s (setq i (1+ i))))
			(setq obj 
				(vla-adddimaligned sp 
					(3d (setq p1 (dxf 10 e))) 
                    (3d (setq p2 (dxf 11 e)))     
					(3d (polar p1 (+ (angle p1 p2) (/ pi 2.)) 0))
                )			
			)
			(vla-put-Textrotation obj (rAng (angle p1 p2)))
			(vla-put-TextOverride obj "<>\\P   ")
			(mapcar 'rSup '(DimLine1Suppress DimLine2Suppress ExtLine1Suppress ExtLine2Suppress))
	)	
)
))
  • Vote tăng 2

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Tks bác sẳn cho em hỏi trong đoạn code sau em sai chỗ nào với ạ

(Setq a (getstring "\n Nhập tên lô đất")

B (getreal "\n nhập số bắt đầu)

C 0)

(While

(Setq d (strcat a (+ b c))

C (+ c 1))

)

(Princ d) -> tới đây thì báo lỗi

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Strcat yêu cầu đối số là các string. Trong đây bạn lại có tổng của b + c = số thực.

Ngoài ra hàm while của bạn đang không có điều kiện thoát

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Itoa lại là hàm chuyển đổi Integer sang String, trong khi b của bạn là Getreal => Kiểu số Real. (+ b c) trả về Real => lỗi

Khi sử dụng các hàm bạn phải chú ý yêu cầu về đối số của nó để cung cấp cho đúng, đừng vội vàng

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

 

Quick code cho bạn :

(defun c:qdd(/ s sp 3d i dxf rAng rSup e obj) (vl-load-com)
;Quick dim Lines @ketxu 10/2016
(cond
	((setq s (ssget '((0 . "LINE")))) 
	(setq 	sp	(vlax-get (setq ac (vla-get-activedocument (vlax-get-acad-object)))
					(if (> (vla-get-activespace  ac) 0) 'ModelSpace 'PaperSpace)) 
			3d vlax-3d-point
			i -1
			dxf (lambda(i e)(cdr (assoc i (entget e))))
			rAng (lambda(a)(if (and (> a (/ pi 2.)) (<= a (* pi 1.5)))(+ a pi) a))
			rSup (lambda(p)(vlax-put-property obj p 1))
			
	)
	(while (setq e (ssname s (setq i (1+ i))))
			(setq obj 
				(vla-adddimaligned sp 
					(3d (setq p1 (dxf 10 e))) 
                    (3d (setq p2 (dxf 11 e)))     
					(3d (polar p1 (+ (angle p1 p2) (/ pi 2.)) 0))
                )			
			)
			(vla-put-Textrotation obj (rAng (angle p1 p2)))
			(vla-put-TextOverride obj "<>\\P   ")
			(mapcar 'rSup '(DimLine1Suppress DimLine2Suppress ExtLine1Suppress ExtLine2Suppress))
	)	
)
))

Bạn ơi mình muốn chiều dài cạnh chỉ lấy 1 số sau dấu , và chọn nhập chiều cao chữ thì làm như thế nào??? Xin cảm ơn!

  • Vote giảm 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Bạn ơi mình muốn chiều dài cạnh chỉ lấy 1 số sau dấu , và chọn nhập chiều cao chữ thì làm như thế nào??? Xin cảm ơn!

 

"Text" bạn nhìn thấy thực chất là các đường dimention kích thước do bác @KetXu đã ẩn đi các đường gióng rồi.

 Muốn thay đổi số sau dấu phẩy hay là chiều cao chữ thì cứ vào "Dimention Style" hiện tại mà thay đổi theo ý thích thôi.  :D :D

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

nhờ các bác sửa giúp lại cái lips ghi độ dài trên em với. em muốn nó:

1. ghi với cả nét Polyline (lips trên chỉ ghi với Line),

2. chữ dạng text cao 3,5 (không phải dim)

3. là 1 layer mới (ví dụ layer "ghi kích thước" và có màu đỏ) để tiện ẩn đi.

  • Vote giảm 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Tạo một tài khoản hoặc đăng nhập để nhận xét

Bạn cần phải là một thành viên để lại một bình luận

Tạo tài khoản

Đăng ký một tài khoản mới trong cộng đồng của chúng tôi. Điều đó dễ mà.

Đăng ký tài khoản mới

Đăng nhập

Bạn có sẵn sàng để tạo một tài khoản ? Đăng nhập tại đây.

Đăng nhập ngay

Đăng nhập để thực hiện theo  

×